/*
 * effect.h
 *
 * Last modified: <2008/08/27 03:45:54 +0900> By SUMIDA
 */
#ifndef EFFECT_H_INCLUDED
#define EFFECT_H_INCLUDED

#include "real.h"
#include "sprite.h"

typedef enum EFFECT_ID {

	EFFECT_ID_EXPLOSION = 0,
	EFFECT_ID_BOMB,
	EFFECT_ID_DISPERSE,
	EFFECT_ID_POWERUP,
	EFFECT_ID_HIT,
	EFFECT_ID_HIT2,
	EFFECT_ID_STARS1,
	EFFECT_ID_STARS2,
	EFFECT_ID_MAX

} EFFECT_ID;

typedef struct EFFECT_INFO {

	struct EFFECT_INFO *next;
	int id;
	SPRITE sprite;

} EFFECT_INFO;

typedef struct EFFECT_MGR {
	EFFECT_INFO *active;
	EFFECT_INFO *pool;
} EFFECT_MGR;

extern void effect_init(void);

extern void effect_action(void);

extern void effect_clean(void);

extern EFFECT_INFO *effect_new(EFFECT_ID id);

extern void effect_set_pos(EFFECT_INFO *info, SPRITE *spr, Real ox, Real oy);

#endif
