/*
 * enemy3.c
 *
 * Last modified: <2008/08/08 08:43:58 +0900> By SUMIDA
 */
#include <SDL.h>
#include "system.h"
#include "texture.h"
#include "ship.h"
#include "shot.h"
#include "enemy.h"
#include "effect.h"
#include "sound.h"

extern SHIP_MGR enemy_mgr;

void enemy3_init(SHIP_INFO *info) {

	REPORT(format("info=%p, id=%d", info, info->id));
	info->sprite.dx = IntToReal(1)>>1;
}

void enemy3(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship) {

	switch (info->stat) {
	case SHIP_STAT_APPEAR:
		/* @ɕύX */
		if (info->sprite.y < ship->sprite.y && info->sprite.dy < 0
			|| info->sprite.y > ship->sprite.y && info->sprite.dy > 0) {

			info->sprite.dy = -info->sprite.dy;
		}

		if (info->count < 0) {
			info->count = 5;
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	case SHIP_STAT_MOVE:
		if (info->count < 0) {
			info->count = 5;
			info->stat = SHIP_STAT_NORMAL;
		}
		break;

	case SHIP_STAT_NORMAL:
		if (info->count < 0 && Random(-1, 128) < system_info.level) {
			info->count = 5;
			info->stat = SHIP_STAT_FIRE;
		}
		break;

	case SHIP_STAT_FIRE:
		if (info->count < 0) {
			/* e̔ */
			SHIP_INFO *snow = enemy_new(&enemy_mgr, SHIP_ID_SNOWFLAKE,
										info->sprite.x + IntToReal(30-8),
										info->sprite.y);

			if (snow != NULL) {
				snow->sprite.dx = IntToReal(2);
			}

			info->count = 10;
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	default:
		return;
	}
}

void enemy3_term(SHIP_INFO *info) {
	REPORT(format("info=%p", info));
}
