/*
 * enemy4.c
 *
 * Last modified: <2008/08/08 08:43:38 +0900> By SUMIDA
 */
#include <SDL.h>
#include "system.h"
#include "texture.h"
#include "ship.h"
#include "shot.h"
#include "enemy.h"
#include "effect.h"
#include "sound.h"

void enemy4_init(SHIP_INFO *info) {

	REPORT(format("info=%p, id=%d", info, info->id));
	info->sprite.dx = IntToReal(1);
}

void enemy4(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship) {

	switch (info->stat) {
	case SHIP_STAT_APPEAR:
		if (info->count < 0) {
			info->count = 5;
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	case SHIP_STAT_MOVE:
		if (info->count < 0) {
			/* @ɕύX */
			if (info->sprite.y < ship->sprite.y)
				info->sprite.dy = IntToReal((int)Random(2, 6));
			else if (info->sprite.y > ship->sprite.y)
				info->sprite.dy = -IntToReal((int)Random(2, 6));
			else
				info->sprite.dy = 0;

			info->count = 5;
			info->stat = SHIP_STAT_NORMAL;
		}
		break;

	case SHIP_STAT_NORMAL:
		if (info->count < 0) {
			if (Random(0, 32) < system_info.level) {
				info->sprite.dx = IntToReal(1);
				info->sprite.dy = 0;
				info->count = 5;
				info->stat = SHIP_STAT_FIRE;

			} else {
				info->sprite.dx = IntToReal(1);
				info->count = 60;
				info->stat = SHIP_STAT_MOVE;
			}
		}
		break;

	case SHIP_STAT_FIRE:
		if (info->count < 0 && Random(0, 128) < system_info.level) {
			/* [U[̔ */
			SHOT_INFO *shot = shot_new(shot_mgr, SHOT_ID_RAY1);

			if (shot != NULL) {
				shot_fire(shot, info, 0, IntToReal(16));
				shot->sprite.dx = IntToReal(2);
				sound_effect(SE_SHOT0);
			}

			info->sprite.dx = IntToReal(1);
			info->count = 60;
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	default:
		return;
	}

	/* ʒ[Ŕ] */
	if (info->sprite.dy < 0 && info->sprite.y < IntToReal(10)
		|| info->sprite.dy > 0 && info->sprite.y > IntToReal(HEIGHT - 40)) {
		info->sprite.dy = -info->sprite.dy;
	}
}

void enemy4_term(SHIP_INFO *info) {
	REPORT(format("info=%p", info));
}
