/*
 * enemy8.c
 *
 * Last modified: <2008/08/08 08:42:43 +0900> By SUMIDA
 */
#include <SDL.h>
#include "system.h"
#include "texture.h"
#include "ship.h"
#include "shot.h"
#include "enemy.h"
#include "effect.h"
#include "sound.h"

extern SHIP_MGR enemy_mgr;

void enemy8_init(SHIP_INFO *info) {

	REPORT(format("info=%p, id=%d", info, info->id));
	info->sprite.dx = IntToReal(1);
	info->sprite.dy = IntToReal(0);
	info->count = (int)Random(30, 150);
}

void enemy8(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship) {

	switch (info->stat) {
	case SHIP_STAT_APPEAR:
		info->sprite.y = IntToReal(HEIGHT - 18);
		if (info->count < 0) {
			info->count = 30;
			info->sprite.dy = IntToReal(-2);
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	case SHIP_STAT_MOVE:
		if (info->count < 0) {
			info->count = 5;
			info->sprite.dy = IntToReal(0);
			info->stat = SHIP_STAT_NORMAL;
		}
		break;

	case SHIP_STAT_NORMAL:
		if (info->count < 0 && Random(0, 128) < system_info.level) {
			info->count = 5;
			info->stat = SHIP_STAT_FIRE;
		}
		break;

	case SHIP_STAT_FIRE:
		if (info->count < 0 && Random(0, 128) < system_info.level) {
			/* e̔ */
			SHIP_INFO *snow = enemy_new(&enemy_mgr, SHIP_ID_SNOWFLAKE,
										info->sprite.x + IntToReal(86),
										info->sprite.y + IntToReal(6));

			if (snow != NULL) {
				shot_homing(&snow->sprite, &ship->sprite, IntToReal(2));
			}

			info->count = 5;
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	default:
		return;
	}
}

void enemy8_term(SHIP_INFO *info) {
	REPORT(format("info=%p", info));
}
